/* ================================================================ 
* defs
*
***************************************************************************/

#include "options.h"
#include "stdio.h"
#define SNUG_VERSION  "1.5"
#define WELCOME \
"Snuggles version " SNUG_VERSION " \n\n" \
"Snuggles is under the GNU GENERAL PUBLIC LICENSE AGREEMENT,\n" \
"and comes with ABSOLUTELY NO WARRANTY. This is free software, and you are\n" \
"welcome to redistribute it under certain conditions.\n\n" \
"     Email: teleco@dog.ucdavis.edu\n" \
"       WWW: http://dog.ucdavis.edu/~teleco/\n" \
"\n"

#define STOP 0
#define PLAY 1
#define NOLOOP 0
#define LOOP 1
#define TRIM 1000
#define CDR 1
#define WAV 0 
#define RAW 2
#define MAX_SONGS 99 /*99 is the max right now*/

#define FERR_OK         0
#define FERR_MALLOC     1
#define FERR_FOPEN      2
#define FERR_FREAD      3
#define FERR_FUNK_SIG   4
#define FERR_FCORRUPT   5
#define FERR_PAT_LIM    6
#define FERR_OLD_FK     7
#define FERR_FCREATE    8
#define FERR_FWRITE     9
#define FERR_ESEQTABLE  10
#define FERR_SAMUNKNOWN 11
#define FERR_MODCOMPLEX 12
#define FERR_SNGUNKNOWN 13
#define FERR_PREC_NN    14

#define EM_MAIN     3
#define EM_QUIT     4
#define EM_SNUG     5
#define EM_EFFECT   6

/******************************************
* defs for 32bit Linux 1.2.13
*
* we use these to reference alignment critical
* structures in our funk file
*
******************************************/
typedef                char sDB;  /*1 byte*/
typedef unsigned       char uDB;
typedef          short int  sDW;  /*2 bytes*/
typedef unsigned short int  uDW;
typedef                int  sDD;  /*4 bytes*/
typedef unsigned       int  uDD;
typedef             double  sDQ;  /*ansi double - 8 bytes*/

typedef struct
{
	unsigned short	chans ;
	unsigned long	srate ;
	unsigned short	blkalign ;
	unsigned short	depth ;
	unsigned long	datalen;
	unsigned short	datastart;
}
tfileinfo;

typedef struct
{
	unsigned long	endpos;
	unsigned long	startpos;
	unsigned long	curpos;
	FILE			*fp;
	float			vol;
	long			*buf;			
	long			(*read)();
	int		loop;
	int 			playing;
}
tloopinfo;

typedef struct _tsong{ 
  	sDB		sname[19];
	char 	title[40];
	int		hk;
	int 	pathsize;
	tloopinfo loop;
	tfileinfo info;
}tsong;
